Open CASCADE Technology: Bisector_BisecCC Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
Bisector_BisecCC Class Reference

Construct the bisector between two curves. The curves can intersect only in their extremities. More...

`#include <Bisector_BisecCC.hxx>`

Inheritance diagram for Bisector_BisecCC:
[legend]

## Public Member Functions
| Bisector_BisecCC ()
| Bisector_BisecCC (const Handle< Geom2d_Curve > &Cu1, const Handle< Geom2d_Curve > &Cu2, const Standard_Real Side1, const Standard_Real Side2, const gp_Pnt2d &Origin, const Standard_Real DistMax=500)
| Constructs the bisector between the curves <Cu1> and <Cu2>. More...
void | Perform (const Handle< Geom2d_Curve > &Cu1, const Handle< Geom2d_Curve > &Cu2, const Standard_Real Side1, const Standard_Real Side2, const gp_Pnt2d &Origin, const Standard_Real DistMax=500)
| Computes the bisector between the curves <Cu1> and <Cu2>. More...
Standard_Boolean | IsExtendAtStart () const
Standard_Boolean | IsExtendAtEnd () const
void | Reverse ()
| Changes the direction of parametrization of <me>. The "FirstParameter" and the "LastParameter" are not changed but the orientation of the curve is modified. If the curve is bounded the StartPoint of the initial curve becomes the EndPoint of the reversed curve and the EndPoint of the initial curve becomes the StartPoint of the reversed curve. More...
Standard_Real | ReversedParameter (const Standard_Real U) const
| Computes the parameter on the reversed curve for the point of parameter U on this curve. Note: The point of parameter U on this curve is identical to the point of parameter ReversedParameter(U) on the reversed curve. More...
Standard_Boolean | IsCN (const Standard_Integer N) const
| Returns the order of continuity of the curve. Raised if N < 0. More...
Handle< Bisector_BisecCC > | ChangeGuide () const
| The parameter on <me> is linked to the parameter on the first curve. This method creates the same bisector where the curves are inversed. More...
Handle< Geom2d_Geometry > | Copy () const
void | Transform (const gp_Trsf2d &T)
| Transformation of a geometric object. This tansformation can be a translation, a rotation, a symmetry, a scaling or a complex transformation obtained by combination of the previous elementaries transformations. More...
Standard_Real | FirstParameter () const
| Returns the value of the first parameter. Warnings : It can be RealFirst or RealLast from package Standard if the curve is infinite. More...
Standard_Real | LastParameter () const
| Value of the last parameter. Warnings : It can be RealFirst or RealLast from package Standard if the curve is infinite. More...
GeomAbs_Shape | Continuity () const
| It is the global continuity of the curve : C0 : only geometric continuity, C1 : continuity of the first derivative all along the Curve, C2 : continuity of the second derivative all along the Curve, C3 : continuity of the third derivative all along the Curve, G1 : tangency continuity all along the Curve, G2 : curvature continuity all along the Curve, CN : the order of continuity is infinite. More...
Standard_Integer | NbIntervals () const
| If necessary, breaks the curve in intervals of continuity <C1>. And returns the number of intervals. More...
Standard_Real | IntervalFirst (const Standard_Integer Index) const
| Returns the first parameter of the current interval. More...
Standard_Real | IntervalLast (const Standard_Integer Index) const
| Returns the last parameter of the current interval. More...
GeomAbs_Shape | IntervalContinuity () const
Standard_Boolean | IsClosed () const
| Returns true if the curve is closed. Examples : Some curves such as circle are always closed, others such as line are never closed (by definition). Some Curves such as OffsetCurve can be closed or not. These curves are considered as closed if the distance between the first point and the last point of the curve is lower or equal to the Resolution from package gp wich is a fixed criterion independant of the application. More...
Standard_Boolean | IsPeriodic () const
| Returns true if the parameter of the curve is periodic. It is possible only if the curve is closed and if the following relation is satisfied : for each parametric value U the distance between the point P(u) and the point P (u + T) is lower or equal to Resolution from package gp, T is the period and must be a constant. There are three possibilities : . the curve is never periodic by definition (SegmentLine) . the curve is always periodic by definition (Circle) . the curve can be defined as periodic (BSpline). In this case a function SetPeriodic allows you to give the shape of the curve. The general rule for this case is : if a curve can be periodic or not the default periodicity set is non periodic and you have to turn (explicitly) the curve into a periodic curve if you want the curve to be periodic. More...
gp_Pnt2d | ValueAndDist (const Standard_Real U, Standard_Real &U1, Standard_Real &U2, Standard_Real &Distance) const
| Returns the point of parameter U. Computes the distance between the current point and the two curves I separate. Computes the parameters on each curve corresponding of the projection of the current point. More...
gp_Pnt2d | ValueByInt (const Standard_Real U, Standard_Real &U1, Standard_Real &U2, Standard_Real &Distance) const
| Returns the point of parameter U. Computes the distance between the current point and the two curves I separate. Computes the parameters on each curve corresponding of the projection of the current point. More...
void | D0 (const Standard_Real U, gp_Pnt2d &P) const
| Returns in P the point of parameter U. If the curve is periodic then the returned point is P(U) with U = Ustart + (U - Uend) where Ustart and Uend are the parametric bounds of the curve. More...
void | D1 (const Standard_Real U, gp_Pnt2d &P, gp_Vec2d &V) const
| Returns the point P of parameter U and the first derivative V1. Raised if the continuity of the curve is not C1. More...
void | D2 (const Standard_Real U, gp_Pnt2d &P, gp_Vec2d &V1, gp_Vec2d &V2) const
| Returns the point P of parameter U, the first and second derivatives V1 and V2. Raised if the continuity of the curve is not C2. More...
void | D3 (const Standard_Real U, gp_Pnt2d &P, gp_Vec2d &V1, gp_Vec2d &V2, gp_Vec2d &V3) const
| Returns the point P of parameter U, the first, the second and the third derivative. Raised if the continuity of the curve is not C3. More...
gp_Vec2d | DN (const Standard_Real U, const Standard_Integer N) const
| For the point of parameter U of this curve, computes the vector corresponding to the Nth derivative. Exceptions StdFail_UndefinedDerivative if: More...
Standard_Boolean | IsEmpty () const
Standard_Real | LinkBisCurve (const Standard_Real U) const
| Returns the parameter on the curve1 of the projection of the point of parameter U on <me>. More...
Standard_Real | LinkCurveBis (const Standard_Real U) const
| Returns the reciproque of LinkBisCurve. More...
Standard_Real | Parameter (const gp_Pnt2d &P) const
Handle< Geom2d_Curve > | Curve (const Standard_Integer IndCurve) const
const Bisector_PolyBis & | Polygon () const
void | Dump (const Standard_Integer Deep=0, const Standard_Integer Offset=0) const
Public Member Functions inherited from Geom2d_Curve
virtual Standard_Real | TransformedParameter (const Standard_Real U, const gp_Trsf2d &T) const
| Computes the parameter on the curve transformed by T for the point of parameter U on this curve. Note: this function generally returns U but it can be redefined (for example, on a line). More...
virtual Standard_Real | ParametricTransformation (const gp_Trsf2d &T) const
| Returns the coefficient required to compute the parametric transformation of this curve when transformation T is applied. This coefficient is the ratio between the parameter of a point on this curve and the parameter of the transformed point on the new curve transformed by T. Note: this function generally returns 1. but it can be redefined (for example, on a line). More...
Handle< Geom2d_Curve > | Reversed () const
| Creates a reversed duplicate Changes the orientation of this curve. The first and last parameters are not changed, but the parametric direction of the curve is reversed. If the curve is bounded: More...
virtual Standard_Real | Period () const
| Returns thne period of this curve. raises if the curve is not periodic. More...
gp_Pnt2d | Value (const Standard_Real U) const
| Computes the point of parameter U on <me>. If the curve is periodic then the returned point is P(U) with U = Ustart + (U - Uend) where Ustart and Uend are the parametric bounds of the curve. More...
Public Member Functions inherited from Geom2d_Geometry
void | Mirror (const gp_Pnt2d &P)
| Performs the symmetrical transformation of a Geometry with respect to the point P which is the center of the symmetry and assigns the result to this geometric object. More...
void | Mirror (const gp_Ax2d &A)
| Performs the symmetrical transformation of a Geometry with respect to an axis placement which is the axis of the symmetry. More...
void | Rotate (const gp_Pnt2d &P, const Standard_Real Ang)
| Rotates a Geometry. P is the center of the rotation. Ang is the angular value of the rotation in radians. More...
void | Scale (const gp_Pnt2d &P, const Standard_Real S)
| Scales a Geometry. S is the scaling value. More...
void | Translate (const gp_Vec2d &V)
| Translates a Geometry. V is the vector of the tanslation. More...
void | Translate (const gp_Pnt2d &P1, const gp_Pnt2d &P2)
| Translates a Geometry from the point P1 to the point P2. More...
Handle< Geom2d_Geometry > | Mirrored (const gp_Pnt2d &P) const
Handle< Geom2d_Geometry > | Mirrored (const gp_Ax2d &A) const
Handle< Geom2d_Geometry > | Rotated (const gp_Pnt2d &P, const Standard_Real Ang) const
Handle< Geom2d_Geometry > | Scaled (const gp_Pnt2d &P, const Standard_Real S) const
Handle< Geom2d_Geometry > | Transformed (const gp_Trsf2d &T) const
Handle< Geom2d_Geometry > | Translated (const gp_Vec2d &V) const
Handle< Geom2d_Geometry > | Translated (const gp_Pnt2d &P1, const gp_Pnt2d &P2) const
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Detailed Description

Construct the bisector between two curves. The curves can intersect only in their extremities.

## Constructor & Destructor Documentation

Bisector_BisecCC::Bisector_BisecCC | ( |  | ) |

Bisector_BisecCC::Bisector_BisecCC | ( | const Handle< Geom2d_Curve > & | Cu1,
|  | const Handle< Geom2d_Curve > & | Cu2,
|  | const Standard_Real | Side1,
|  | const Standard_Real | Side2,
|  | const gp_Pnt2d & | Origin,
|  | const Standard_Real | DistMax = `500`
| ) |  |

Constructs the bisector between the curves <Cu1> and <Cu2>.

<Side1> (resp <Side2>) = 1 if the bisector curve is on the left of <Cu1> (resp <Cu2>) else <Side1> (resp <Side2>) = -1.

the Bisector is trimmed by the Point <Origin>. <DistMax> is used to trim the bisector.The distance between the points of the bisector and <Cu> is smaller than <DistMax>.

## Member Function Documentation

Handle< Bisector_BisecCC > Bisector_BisecCC::ChangeGuide | ( |  | ) | const

The parameter on <me> is linked to the parameter on the first curve. This method creates the same bisector where the curves are inversed.

GeomAbs_Shape Bisector_BisecCC::Continuity | ( |  | ) | const
| virtual

It is the global continuity of the curve : C0 : only geometric continuity, C1 : continuity of the first derivative all along the Curve, C2 : continuity of the second derivative all along the Curve, C3 : continuity of the third derivative all along the Curve, G1 : tangency continuity all along the Curve, G2 : curvature continuity all along the Curve, CN : the order of continuity is infinite.

Implements Geom2d_Curve.

Handle< Geom2d_Geometry > Bisector_BisecCC::Copy | ( |  | ) | const
| virtual

Implements Geom2d_Geometry.

Handle< Geom2d_Curve > Bisector_BisecCC::Curve | ( | const Standard_Integer | IndCurve | ) | const

void Bisector_BisecCC::D0 | ( | const Standard_Real | U,
|  | gp_Pnt2d & | P
| ) |  | const
| virtual

Returns in P the point of parameter U. If the curve is periodic then the returned point is P(U) with U = Ustart + (U - Uend) where Ustart and Uend are the parametric bounds of the curve.

Raised only for the "OffsetCurve" if it is not possible to compute the current point. For example when the first derivative on the basis curve and the offset direction are parallel.

Implements Geom2d_Curve.

void Bisector_BisecCC::D1 | ( | const Standard_Real | U,
|  | gp_Pnt2d & | P,
|  | gp_Vec2d & | V1
| ) |  | const
| virtual

Returns the point P of parameter U and the first derivative V1. Raised if the continuity of the curve is not C1.

Implements Geom2d_Curve.

void Bisector_BisecCC::D2 | ( | const Standard_Real | U,
|  | gp_Pnt2d & | P,
|  | gp_Vec2d & | V1,
|  | gp_Vec2d & | V2
| ) |  | const
| virtual

Returns the point P of parameter U, the first and second derivatives V1 and V2. Raised if the continuity of the curve is not C2.

Implements Geom2d_Curve.

void Bisector_BisecCC::D3 | ( | const Standard_Real | U,
|  | gp_Pnt2d & | P,
|  | gp_Vec2d & | V1,
|  | gp_Vec2d & | V2,
|  | gp_Vec2d & | V3
| ) |  | const
| virtual

Returns the point P of parameter U, the first, the second and the third derivative. Raised if the continuity of the curve is not C3.

Implements Geom2d_Curve.

gp_Vec2d Bisector_BisecCC::DN | ( | const Standard_Real | U,
|  | const Standard_Integer | N
| ) |  | const
| virtual

For the point of parameter U of this curve, computes the vector corresponding to the Nth derivative. Exceptions StdFail_UndefinedDerivative if:

- the continuity of the curve is not "CN", or
- the derivative vector cannot be computed easily; this is the case with specific types of curve (for example, a rational BSpline curve where N is greater than 3). Standard_RangeError if N is less than 1.

Implements Geom2d_Curve.

void Bisector_BisecCC::Dump | ( | const Standard_Integer | Deep = `0`,
|  | const Standard_Integer | Offset = `0`
| ) |  | const

Standard_Real Bisector_BisecCC::FirstParameter | ( |  | ) | const
| virtual

Returns the value of the first parameter. Warnings : It can be RealFirst or RealLast from package Standard if the curve is infinite.

Implements Geom2d_Curve.

GeomAbs_Shape Bisector_BisecCC::IntervalContinuity | ( |  | ) | const

Standard_Real Bisector_BisecCC::IntervalFirst | ( | const Standard_Integer | Index | ) | const
| virtual

Returns the first parameter of the current interval.

Implements Bisector_Curve.

Standard_Real Bisector_BisecCC::IntervalLast | ( | const Standard_Integer | Index | ) | const
| virtual

Returns the last parameter of the current interval.

Implements Bisector_Curve.

Standard_Boolean Bisector_BisecCC::IsClosed | ( |  | ) | const
| virtual

Returns true if the curve is closed. Examples : Some curves such as circle are always closed, others such as line are never closed (by definition). Some Curves such as OffsetCurve can be closed or not. These curves are considered as closed if the distance between the first point and the last point of the curve is lower or equal to the Resolution from package gp wich is a fixed criterion independant of the application.

Implements Geom2d_Curve.

Standard_Boolean Bisector_BisecCC::IsCN | ( | const Standard_Integer | N | ) | const
| virtual

Returns the order of continuity of the curve. Raised if N < 0.

Implements Geom2d_Curve.

Standard_Boolean Bisector_BisecCC::IsEmpty | ( |  | ) | const

Standard_Boolean Bisector_BisecCC::IsExtendAtEnd | ( |  | ) | const
| virtual

Implements Bisector_Curve.

Standard_Boolean Bisector_BisecCC::IsExtendAtStart | ( |  | ) | const
| virtual

Implements Bisector_Curve.

Standard_Boolean Bisector_BisecCC::IsPeriodic | ( |  | ) | const
| virtual

Returns true if the parameter of the curve is periodic. It is possible only if the curve is closed and if the following relation is satisfied : for each parametric value U the distance between the point P(u) and the point P (u + T) is lower or equal to Resolution from package gp, T is the period and must be a constant. There are three possibilities : . the curve is never periodic by definition (SegmentLine) . the curve is always periodic by definition (Circle) . the curve can be defined as periodic (BSpline). In this case a function SetPeriodic allows you to give the shape of the curve. The general rule for this case is : if a curve can be periodic or not the default periodicity set is non periodic and you have to turn (explicitly) the curve into a periodic curve if you want the curve to be periodic.

Implements Geom2d_Curve.

Standard_Real Bisector_BisecCC::LastParameter | ( |  | ) | const
| virtual

Value of the last parameter. Warnings : It can be RealFirst or RealLast from package Standard if the curve is infinite.

Implements Geom2d_Curve.

Standard_Real Bisector_BisecCC::LinkBisCurve | ( | const Standard_Real | U | ) | const

Returns the parameter on the curve1 of the projection of the point of parameter U on <me>.

Standard_Real Bisector_BisecCC::LinkCurveBis | ( | const Standard_Real | U | ) | const

Returns the reciproque of LinkBisCurve.

Standard_Integer Bisector_BisecCC::NbIntervals | ( |  | ) | const
| virtual

If necessary, breaks the curve in intervals of continuity <C1>. And returns the number of intervals.

Implements Bisector_Curve.

Standard_Real Bisector_BisecCC::Parameter | ( | const gp_Pnt2d & | P | ) | const
| virtual

Implements Bisector_Curve.

void Bisector_BisecCC::Perform | ( | const Handle< Geom2d_Curve > & | Cu1,
|  | const Handle< Geom2d_Curve > & | Cu2,
|  | const Standard_Real | Side1,
|  | const Standard_Real | Side2,
|  | const gp_Pnt2d & | Origin,
|  | const Standard_Real | DistMax = `500`
| ) |  |

Computes the bisector between the curves <Cu1> and <Cu2>.

<Side1> (resp <Side2>) = 1 if the bisector curve is on the left of <Cu1> (resp <Cu2>) else <Side1> (resp <Side2>) = -1.

the Bisector is trimmed by the Point <Origin>.

<DistMax> is used to trim the bisector.The distance between the points of the bisector and <Cu> is smaller than <DistMax>.

const Bisector_PolyBis& Bisector_BisecCC::Polygon | ( |  | ) | const

void Bisector_BisecCC::Reverse | ( |  | ) |
| virtual

Changes the direction of parametrization of <me>. The "FirstParameter" and the "LastParameter" are not changed but the orientation of the curve is modified. If the curve is bounded the StartPoint of the initial curve becomes the EndPoint of the reversed curve and the EndPoint of the initial curve becomes the StartPoint of the reversed curve.

Implements Geom2d_Curve.

Standard_Real Bisector_BisecCC::ReversedParameter | ( | const Standard_Real | U | ) | const
| virtual

Computes the parameter on the reversed curve for the point of parameter U on this curve. Note: The point of parameter U on this curve is identical to the point of parameter ReversedParameter(U) on the reversed curve.

Implements Geom2d_Curve.

void Bisector_BisecCC::Transform | ( | const gp_Trsf2d & | T | ) |
| virtual

Transformation of a geometric object. This tansformation can be a translation, a rotation, a symmetry, a scaling or a complex transformation obtained by combination of the previous elementaries transformations.

Implements Geom2d_Geometry.

gp_Pnt2d Bisector_BisecCC::ValueAndDist | ( | const Standard_Real | U,
|  | Standard_Real & | U1,
|  | Standard_Real & | U2,
|  | Standard_Real & | Distance
| ) |  | const

Returns the point of parameter U. Computes the distance between the current point and the two curves I separate. Computes the parameters on each curve corresponding of the projection of the current point.

gp_Pnt2d Bisector_BisecCC::ValueByInt | ( | const Standard_Real | U,
|  | Standard_Real & | U1,
|  | Standard_Real & | U2,
|  | Standard_Real & | Distance
| ) |  | const

Returns the point of parameter U. Computes the distance between the current point and the two curves I separate. Computes the parameters on each curve corresponding of the projection of the current point.

The documentation for this class was generated from the following file:

- Bisector_BisecCC.hxx